﻿using System;
using System.Collections;
using System.Windows.Forms;

namespace Lab4
{
    public delegate IEnumerable ItemsProvider();

    public partial class MainForm : Form
    {
        private readonly ItemsProvider _libriProvider;
        private readonly ItemsProvider _personeProvider;
        private readonly AutoForm _autoForm = new AutoForm();
        //private readonly SearchForm _searchForm = new SearchForm();

        public event AzioneSuLibro NuovoLibro;
        public event AzioneSuLibro ModificaLibro;
        public event AzioneSuPersona NuovaPersona;
        public event AzioneSuPersona ModificaPersona;

        public MainForm()
        {
            InitializeComponent();
        }

        public MainForm(ItemsProvider libriProvider, ItemsProvider personeProvider)
            : this()
        {
            if (libriProvider == null)
                throw new ArgumentNullException("libriProvider");
            if (personeProvider == null)
                throw new ArgumentNullException("personeProvider");
            _libriProvider = libriProvider;
            _personeProvider = personeProvider;
        }

        private void _newLibroBt_Click(object sender, EventArgs e)
        {
            Libro libro = new Libro();
            _autoForm.SetEditableObject(libro, false);
            if (_autoForm.ShowDialog() == DialogResult.OK)
            {
                OnNuovoLibro(libro);
            }
        }

        private void _newPersonaBt_Click(object sender, EventArgs e)
        {
            Persona persona = new Persona();
            _autoForm.SetEditableObject(persona, false);
            if (_autoForm.ShowDialog() == DialogResult.OK)
            {
                OnNuovaPersona(persona);
            }
        }

        private void _modLibroBt_Click(object sender, EventArgs e)
        {
            //_searchForm.LoadItems(_libriProvider());
            //if (_searchForm.ShowDialog() != DialogResult.OK || _searchForm.SelectedItem == null)
            //    return;

            //Libro libro = (Libro) _searchForm.SelectedItem;
            //_autoForm.SetEditableObject(libro, true);
            //if (_autoForm.ShowDialog() == DialogResult.OK)
            //{
            //    OnModificaLibro(libro);
            //}
        }

        private void _modPersonaBt_Click(object sender, EventArgs e)
        {
            //_searchForm.LoadItems(_personeProvider());
            //if (_searchForm.ShowDialog() != DialogResult.OK || _searchForm.SelectedItem == null)
            //    return;

            //Persona persona = (Persona) _searchForm.SelectedItem;
            //_autoForm.SetEditableObject(persona, true);
            //if (_autoForm.ShowDialog() == DialogResult.OK)
            //{
            //    OnModificaPersona(persona);
            //}
        }

        protected virtual void OnNuovoLibro(Libro libro)
        {
            if (NuovoLibro != null)
            {
                NuovoLibro(libro);
            }
        }

        protected virtual void OnNuovaPersona(Persona persona)
        {
            if (NuovaPersona != null)
            {
                NuovaPersona(persona);
            }
        }

        protected virtual void OnModificaLibro(Libro libro)
        {
            if (ModificaLibro != null)
            {
                ModificaLibro(libro);
            }
        }

        protected virtual void OnModificaPersona(Persona persona)
        {
            if (ModificaPersona != null)
            {
                ModificaPersona(persona);
            }
        }
    }
}
