using System;

namespace Lab4
{
    public class Persona
    {
        private readonly int _id;
        private string _nome;
        private string _indirizzo;
        private string _telefono;
        private static int _nextId = 1;

        internal Persona()
            : this(String.Empty, String.Empty, String.Empty)
        {
        }

        public Persona(string nome, string indirizzo, string telefono)
        {
            if (nome == null)
                throw new ArgumentNullException("nome");
            if (indirizzo == null)
                throw new ArgumentNullException("indirizzo");
            if (telefono == null)
                throw new ArgumentNullException("telefono");
            _id = _nextId++;
            _nome = nome;
            _indirizzo = indirizzo;
            _telefono = telefono;
        }

        [Editable("Identificatore", Width = 30)]
        public int Id
        {
            get { return _id; }
        }

        [Editable("Nome")]
        public string Nome
        {
            get { return _nome; }
            set
            {
                if (value == null)
                    throw new ArgumentNullException("value");
                if (value == String.Empty)
                    throw new ArgumentException("Il nome della persona  obbligatorio");
                _nome = value;
            }
        }

        [Editable("Indirizzo")]
        public string Indirizzo
        {
            get { return _indirizzo; }
            set
            {
                if (value == null)
                    throw new ArgumentNullException("value");
                _indirizzo = value;
            }
        }

        [Editable("Numero di telefono")]
        public string Telefono
        {
            get { return _telefono; }
            set
            {
                if (value == null)
                    throw new ArgumentNullException("value");
                _telefono = value;
            }
        }

        public override string ToString()
        {
            return Id.ToString() + " - " + Nome;
        }
    }
}
