﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;

namespace Lab4
{
    public delegate void AzioneSuLibro(Libro libro);
    public delegate void AzioneSuPersona(Persona persona);

    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            Biblioteca biblioteca = new Biblioteca();

            MainForm mainForm = new MainForm(delegate { return biblioteca.Libri; }, delegate { return biblioteca.Persone; });

            mainForm.NuovoLibro += biblioteca.Aggiungi;
            mainForm.NuovaPersona += biblioteca.Aggiungi;

            using (Logger logger = new Logger("../../LogFile.xml"))
            {

                mainForm.NuovoLibro += logger.TracciaNuovoLibro;
                mainForm.ModificaLibro += logger.TracciaModificaLibro;
                mainForm.NuovaPersona += logger.TracciaNuovaPersona;
                mainForm.ModificaPersona += logger.TracciaModificaPersona;

                Application.Run(mainForm);
            }
        }
    }
}
